{% extends 'Default/backend.html.twig' %}
{% set locales = app_locales|split('|') %}

{% block stylesheets %}
  {{ parent() }}
  <link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/v/bs4/jq-3.6.0/dt-1.12.1/datatables.min.css"/>
{% endblock %}

{% block javascripts %}
  {{ parent() }}
  <script type="text/javascript" src="https://cdn.datatables.net/v/bs4/jq-3.6.0/dt-1.12.1/datatables.min.js"></script>
  <script>
    const lang = document.documentElement.lang.toString();
    //Default
    let url_language = '//cdn.datatables.net/plug-ins/1.12.1/i18n/it-IT.json';
    if(lang === 'en'){
      url_language = '//cdn.datatables.net/plug-ins/1.12.1/i18n/en-GB.json';
    }else if(lang === 'de'){
      url_language = '//cdn.datatables.net/plug-ins/1.12.1/i18n/de-DE.json';
    }
    // Datatable
    $('#service-table').DataTable({
      "order": [[ 0, "asc" ]],
      columnDefs: [
        { orderable: false, targets: 2 },
        { orderable: false, targets: 3 },
        { orderable: false, targets: 4 },
        { orderable: false, targets: 5 }
      ],
      language: {
        url: url_language
      },
      stateSave: true,
      dom: "<'row'<'col-6 pt-2'l><'col-6'f>>" +
        "<'row'<'col-12'tr>>" +
        "<'row'<'col-sm-12 col-md-5'i><'col-sm-12 col-md-7 mt-2'p>>"
    });

    $('.clone').click(function (e) {
      e.preventDefault()
      let button = $(this)
      let temp = $("<input>")
      $("body").append(temp)
      temp.val(button.data('url')).select()
      document.execCommand("copy")
      temp.remove();
    })
  </script>
{% endblock %}

{% block main_content %}
  <section id="intro" class="container-full px-4 my-4">
    <div class="row">
      <div class="col-lg-12 px-lg-4 py-lg-2">
        <h2>{{ 'nav.admin.servizi'|trans }}</h2>
      </div>

      <div class="col-lg-12 px-lg-4 py-lg-2">
          <table id="service-table" class="table table-striped table-condensed table-sm">
            <thead>
            <tr>
              <th>{{ 'servizio.gruppo'|trans }}<i class="fa fa-caret-right px-2" aria-hidden="true"></i>{{ 'general.nome'|trans }}</th>
              <th>{{ 'servizio.categoria'|trans }}</th>
              <th>{{ 'general.url'|trans }}</th>
              <th>{{ 'servizio.livello_accesso'|trans }}</th>
              <th>{{ 'general.stato'|trans }}</th>
              <th aria-label="{{ 'no_value' | trans() }}" ></th>
            </tr>
            </thead>
            <tbody>
            {% for item in items %}
              <tr>
                <td class="w-60">
                  {% if item.serviceGroup and item.serviceGroup %}
                    <a href="{{ path('admin_service_group_edit', {'id': item.serviceGroup.id}) }}">{{ item.serviceGroup.name }}</a>
                    <i class="fa fa-caret-right px-2" aria-hidden="true"></i>
                  {% endif %}
                  <a class="" href="{{ path('admin_servizio_edit', { 'id': item.id }) }}">{{ item.name }}</a>
                </td>
                <td>
                  {% if item.sharedWithGroup and item.serviceGroup %}
                    {{ item.serviceGroup.topics is  defined ? item.serviceGroup.topics.name : '' }}
                  {% else %}
                    {{ (item.topics) ? item.topics.name : '' }}
                  {% endif %}
                </td>
                <td class="text-nowrap">
                  <a class="btn btn-xs btn-outline-secondary {% if item.externalCardUrl %}disabled{% endif %}" href="{{ absolute_url(path('servizi_show', { 'slug': item.slug })) }}" target="_blank"
                     data-url="{{ absolute_url(path('servizi_show', { 'slug': item.slug })) }}"
                     data-container="body" data-toggle="popover" data-trigger="hover"
                     data-placement="right"
                     data-html="true" title="{{ 'admin.url_service' | trans }}"
                     data-content="{{ 'admin.show_service' | trans }}">
                    <i class="fa fa-external-link" aria-hidden="true"></i>
                    <span class="sr-only">{{ 'admin.show_service' | trans }}</span>
                  </a>
                  {% if item.status != constant('STATUS_DRAFT', item) %}
                    <a class="btn btn-xs btn-outline-secondary clone" href="#"
                       data-url="{{ absolute_url(path('service_api_get', { 'id': item.id })) }}"
                       data-container="body" data-toggle="popover" data-trigger="hover"
                       data-placement="right"
                       data-html="true" title="{{ 'admin.url_api_service' | trans }}"
                       data-content="{{ 'admin.show_api_service' | trans }}">
                      <i class="fa fa-file-code-o" aria-hidden="true"></i>
                      <span class="sr-only">{{ 'admin.show_api_service' | trans }}</span>
                    </a>
                  {% endif %}
                  <a class="btn btn-xs btn-outline-secondary clone" href="#"
                      data-url="{{ absolute_url(path('service_access', { 'servizio': item.slug })) }}"
                      data-container="body" data-toggle="popover" data-trigger="hover"
                      data-placement="right"
                      data-html="true" title="{{ 'admin.url_service_access' | trans }}"
                      data-content="{{ 'admin.show_service_access' | trans }}">
                    <i class="fa fa-key" aria-hidden="true"></i>
                    <span class="sr-only">{{ 'admin.show_service_access' | trans }}</span>
                  </a>
                </td>
                <td>
                  {% if access_levels[item.accessLevel] is defined %}
                    {{ access_levels[item.accessLevel] }}
                  {% endif %}
                </td>
                <td>
                  {% if item.status == constant('\\App\\Entity\\Servizio::STATUS_SCHEDULED') %}
                    {% if not item.isActive %}
                      {{ 'servizio.statutes.schedule_expired' | trans }}
                    {% endif %}
                    <small class="d-block">{{ 'from' | trans }} {{ item.scheduledFrom|format_datetime('medium', 'short', locale=app.request.locale) }}</small>
                    <small class="d-block">{{ 'to' | trans }} {{ item.scheduledTo|format_datetime('medium', 'short', locale=app.request.locale) }}</small>
                  {% else %}
                    {{ ('servizio.statutes.'~item.statusName)|trans }}
                  {% endif %}
                </td>
                <td class="text-right">
                  <div class="dropdown dropdown-actions">
                    <button class="btn btn-link btn-dropdown dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                      <svg class="icon-expand icon align-middle icon-primary"><use xlink:href="/bootstrap-italia/dist/svg/sprite.svg#it-more-actions"></use></svg>
                    </button>
                    <div class="dropdown-menu dropdown-menu-right">
                      <div class="link-list-wrapper">
                        <ul class="link-list">
                          <li>
                            <a class="list-item" href="{{ path('admin_servizio_edit', { 'id': item.id }) }}">
                              <span class="text-primary"><i class="fa fa-file-o fa-lg"></i> {{ 'operatori.dati_generali' | trans }}</span>
                            </a>
                          </li>
                          <li>
                            <a class="list-item" href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'card' }) }}">
                              <span class="text-primary"><i class="fa fa-file-text-o fa-lg"></i> {{ 'operatori.scheda' | trans }}</span>
                            </a>
                          </li>
                          {% if item.formio and item.handler != 'due_payment' %}
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'formio' }) }}">
                                <span class="text-primary"><i class="fa fa-server fa-lg"></i> {{ 'operatori.modulo' | trans }}</span>
                              </a>
                            </li>
                          {% endif %}
                          {% if locales|length > 1 and item.handler != 'due_payment' %}
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'formioI18n' }) }}">
                                <span class="text-primary"><i class="fa fa-language fa-lg"></i>{{ 'servizio.i18n.translations' | trans }}</span>
                              </a>
                            </li>
                          {% endif %}
                          {% if feature('feature_pdnd') and item.handler != 'due_payment' %}
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'pdnd' }) }}">
                                <span class="text-primary"><i class="fa fa-handshake-o fa-lg"></i> {{ 'nav.admin.pdnd' | trans }}</span>
                              </a>
                            </li>
                          {% endif %}
                          {% if item.handler != 'due_payment' %}
                          <li>
                            <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'messages' }) }}">
                              <span class="text-primary"><i class="fa fa-envelope-o fa-lg"></i> {{ 'operatori.messaggi.titolo' | trans }}</span>
                            </a>
                          </li>
                          <li>
                            <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'app-io' }) }}">
                              <span class="text-primary"><i class="fa fa-bullhorn fa-lg"></i> {{ 'app_io.title' | trans }}</span>
                            </a>
                          </li>
                          {% endif %}
                          {% if not item.builtIn and item.handler != 'due_payment' %}
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'stamps' }) }}">
                                <span class="text-primary"><i class="fa fa-barcode fa-lg"></i> {{ 'general.stamps' | trans }}</span>
                              </a>
                            </li>
                          {% endif %}
                          {% if not item.builtIn %}
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'payments' }) }}">
                                <span class="text-primary"><i class="fa fa-credit-card fa-lg"></i> {{ 'backoffice.integration.subscription_service.payments' | trans }}</span>
                              </a>
                            </li>
                          {% endif %}
                          {% if item.handler != 'due_payment' %}
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'protocol' }) }}">
                                <span class="text-primary"><i class="fa fa-folder-open-o fa-lg"></i> {{ 'servizio.protocollo' | trans }}</span>
                              </a>
                            </li>
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'receipt' }) }}">
                                <span class="text-primary"><i class="fa fa-file-pdf-o fa-lg"></i> {{ 'general.receipt' | trans }}</span>
                              </a>
                            </li>
                            {% if feature('feature_custom_templates') %}
                              <li>
                                <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'custom_template' }) }}">
                                  <span class="text-primary"><i class="fa fa-file-code-o fa-lg"></i> {{ 'ente.custom_template.title' | trans }}</span>
                                </a>
                              </li>
                            {% endif %}
                          {% endif %}
                          {% if item.formio %}
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'backoffices' }) }}">
                                <span class="text-primary"><i class="fa fa-cogs fa-lg"></i> {{ 'integrations' | trans }}</span>
                              </a>
                            </li>
                          {% endif %}
                          {% if feature('feature_automatic_applications_assignment') and item.handler != 'due_payment' %}
                            <li>
                              <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'assignment' }) }}">
                                <span class="text-primary"><i class="fa fa-android fa-lg"></i> {{ 'servizio.assignment.title' | trans }}</span>
                              </a>
                            </li>
                          {% endif %}
                          {% if item.handler != 'due_payment' %}
                          <li>
                            <a class="list-item " href="{{ path('admin_servizio_edit', { 'id': item.id, 'step': 'advanced' }) }}">
                              <span class="text-primary"><i class="fa fa-sliders fa-lg"></i> {{ 'operatori.advanced_settings' | trans }}</span>
                            </a>
                          </li>
                          {% endif %}
                          <li>
                            <a class="list-item " onclick="return confirm('{{ 'general.alert_elimina'|trans }}');" href="{{ path('admin_servizio_delete', { 'id': item.id }) }}">
                              <span class="text-danger"><i class="fa fa-trash-o fa-lg"></i> {{ 'elimina'|trans }}</span>
                            </a>
                          </li>
                        </ul>
                      </div>
                    </div>
                  </div>
                </td>
              </tr>
            {% endfor %}
            </tbody>
          </table>
      </div>
      <div class="col-lg-4 px-lg-4 py-lg-2 mt-4">
        <div class="dropdown">
          <button class="btn btn-primary dropdown-toggle" type="button" id="createOperatorButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
            {{ 'aggiungi'|trans }}
            <svg class="icon-expand icon icon-sm icon-light">
              <use xlink:href="/bootstrap-italia/dist/svg/sprite.svg#it-expand"></use>
            </svg>
          </button>
          <div class="dropdown-menu" aria-labelledby="createOperatorButton">
            <a class="dropdown-item"
               href="{{ path('admin_service_new', {'type': 'formio'}) }}">{{ 'nav.admin.request_service'|trans }}</a>
            <a class="dropdown-item"
               href="{{ path('admin_service_new', {'type': 'due_payment' }) }}">{{ 'nav.admin.due_service'|trans }}</a>
          </div>
        </div>
      </div>
      <div class="col-lg-8 px-lg-4 py-lg-2 mt-4">
        <form action="{{ path('admin_servizio_import') }}" method="post">
          <div class="form-group">
            <label for="import-input" class="sr-only">{{ 'servizio.importa'|trans }}</label>
            <div class="input-group">
              <div class="input-group-prepend">
                <div class="input-group-text">
                  <svg class="icon icon-sm icon-secondary">
                    <use xlink:href="/bootstrap-italia/dist/svg/sprite.svg#it-download"></use>
                  </svg>
                </div>
              </div>
              <input type="text" class="form-control" name="url" id="import-input">
              <div class="input-group-append">
                <button class="btn btn-secondary" type="submit">{{ 'servizio.importa'|trans }}</button>
              </div>
            </div>
          </div>
        </form>
      </div>
    </div>
  </section>
{% endblock %}
